<?php

namespace MJ\LoginAsUser\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class LoginLog extends Entity
{
	public function canPurchase()
	{
		$visitor = \XF::visitor();
		return ($this->user_id == $visitor->user_id);
	}

	public static function getStructure(Structure $structure)
	{
		$structure->table = 'xf_mjlau_login_log';
		$structure->shortName = 'MJ\LoginAsUser:LoginLog';
		$structure->primaryKey = 'log_id';
		$structure->columns = [
			'log_id'        => ['type' => self::UINT, 'autoIncrement' => true, 'nullable' => true],
			'user_id'       => ['type' => self::UINT, 'required' => true],
			'login_user_id' => ['type' => self::UINT, 'required' => true],
			'reason'        => ['type' => self::STR, 'default' => ''],
			'ip_address'    => ['type' => self::BINARY, 'maxLength' => 16, 'default' => ''],
			'login_date'    => ['type' => self::UINT, 'default' => \XF::$time]
		];
		$structure->getters = [];
		$structure->relations = [
			'User' => [
				'entity'     => 'XF:User',
				'type'       => self::TO_ONE,
				'conditions' => 'user_id',
				'primary'    => true
			],
			'LoginUser' => [
				'entity'     => 'XF:User',
				'type'       => self::TO_ONE,
				'conditions' =>[['user_id', '=', '$login_user_id']],
				'primary'    => true
			],
		];
		return $structure;
	}
}
